Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -3639,387 +3606,384 @@
 
 
-! ***  Calculate downdraft velocity scale    ***
-! ***  NE PAS UTILISER POUR L'INSTANT ***
-
-!!      do il=1,ncum
-!!        wd(il)=betad*abs(mp(il,icb(il)))*0.01*rrd*t(il,icb(il)) &
-!!                                       /(sigd(il)*p(il,icb(il)))
-!!      enddo
-
-
-! ***  calculate tendencies of lowest level potential temperature  ***
-! ***                      and mixing ratio                        ***
+  ! ***  Calculate downdraft velocity scale    ***
+  ! ***  NE PAS UTILISER POUR L'INSTANT ***
+
+  !!      do il=1,ncum
+  !!        wd(il)=betad*abs(mp(il,icb(il)))*0.01*rrd*t(il,icb(il)) &
+  !!                                       /(sigd(il)*p(il,icb(il)))
+  !!      enddo
+
+
+  ! ***  calculate tendencies of lowest level potential temperature  ***
+  ! ***                      and mixing ratio                        ***
 
   DO il = 1, ncum
-    work(il) = 1.0/(ph(il,1)-ph(il,2))
+    work(il) = 1.0 / (ph(il, 1) - ph(il, 2))
     cbmf(il) = 0.0
   END DO
 
-! - Adiabatic ascent mass flux "ma" and cloud base mass flux "cbmf"
-!-----------------------------------------------------------------
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! - Adiabatic ascent mass flux "ma" and cloud base mass flux "cbmf"
+  !-----------------------------------------------------------------
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   IF (adiab_ascent_mass_flux_depends_on_ejectliq) THEN
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!!! Warning : this option leads to water conservation violation
-!!!           Expert only
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !!! Warning : this option leads to water conservation violation
+    !!!           Expert only
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    DO il = 1, ncum
+      ma(il, nlp) = 0.
+      ma(il, 1) = 0.
+    END DO
+    DO k = nl, 2, -1
+      DO il = 1, ncum
+        ma(il, k) = ma(il, k + 1) * (1. - qta(il, k)) / (1. - qta(il, k - 1)) + m(il, k)
+        cbmf(il) = max(cbmf(il), ma(il, k))
+      END DO
+    END DO
+    DO k = 2, nl
+      DO il = 1, ncum
+        IF (k <icb(il)) THEN
+          ma(il, k) = ma(il, k - 1) + wghti(il, k - 1) * cbmf(il)
+        ENDIF
+      END DO
+    END DO
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !! Line kept for compatibility with earlier versions
+    DO k = 2, nl
+      DO il = 1, ncum
+        IF (k>=icb(il)) THEN
+          cbmf(il) = cbmf(il) + m(il, k)
+        END IF
+      END DO
+    END DO
+
+    DO il = 1, ncum
+      ma(il, nlp) = 0.
+      ma(il, 1) = 0.
+    END DO
+    DO k = nl, 2, -1
+      DO il = 1, ncum
+        ma(il, k) = ma(il, k + 1) + m(il, k)
+      END DO
+    END DO
+    DO k = 2, nl
+      DO il = 1, ncum
+        IF (k <icb(il)) THEN
+          ma(il, k) = ma(il, k - 1) + wghti(il, k - 1) * cbmf(il)
+        ENDIF
+      END DO
+    END DO
+
+  ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  !    PRINT*,'cv3_yield avant ft'
+  ! am is the part of cbmf taken from the first level
   DO il = 1, ncum
-    ma(il, nlp) = 0.
-    ma(il, 1)   = 0.
-  END DO
-  DO k = nl, 2, -1
-    DO il = 1, ncum
-      ma(il, k) = ma(il, k+1)*(1.-qta(il, k))/(1.-qta(il, k-1)) + m(il, k)
-      cbmf(il) = max(cbmf(il), ma(il,k))
-    END DO
-  END DO
-  DO k = 2,nl
-    DO il = 1, ncum
-      IF (k <icb(il)) THEN
-        ma(il, k) = ma(il, k-1) + wghti(il,k-1)*cbmf(il)
-      ENDIF
-    END DO
-  END DO
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-  ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!! Line kept for compatibility with earlier versions
-  DO k = 2, nl
-    DO il = 1, ncum
-      IF (k>=icb(il)) THEN
-        cbmf(il) = cbmf(il) + m(il, k)
-      END IF
-    END DO
-  END DO
-
-  DO il = 1, ncum
-    ma(il, nlp) = 0.
-    ma(il, 1)   = 0.
-  END DO
-  DO k = nl, 2, -1
-    DO il = 1, ncum
-      ma(il, k) = ma(il, k+1) + m(il, k)
-    END DO
-  END DO
-  DO k = 2,nl
-    DO il = 1, ncum
-      IF (k <icb(il)) THEN
-        ma(il, k) = ma(il, k-1) + wghti(il,k-1)*cbmf(il)
-      ENDIF
-    END DO
-  END DO
-
-  ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-!    PRINT*,'cv3_yield avant ft'
-! am is the part of cbmf taken from the first level
-  DO il = 1, ncum
-    am(il) = cbmf(il)*wghti(il, 1)
+    am(il) = cbmf(il) * wghti(il, 1)
   END DO
 
   DO il = 1, ncum
     IF (iflag(il)<=1) THEN
-! convect3      if((0.1*dpinv*am).ge.delti)iflag(il)=4
-!JYG  Correction pour conserver l'eau
-! cc       ft(il,1)=-0.5*lvcp(il,1)*sigd(il)*(evap(il,1)+evap(il,2))          !precip
+      ! convect3      if((0.1*dpinv*am).ge.delti)iflag(il)=4
+      !JYG  Correction pour conserver l'eau
+      ! cc       ft(il,1)=-0.5*lvcp(il,1)*sigd(il)*(evap(il,1)+evap(il,2))          !precip
       IF (cvflag_ice) THEN
-        ft(il, 1) = -lvcp(il, 1)*sigd(il)*evap(il, 1) - &
-                     lfcp(il, 1)*sigd(il)*evap(il, 1)*faci(il, 1) - &
-                     lfcp(il, 1)*sigd(il)*(fondue(il,1)*wt(il,1)) / &
-                       (100.*(ph(il,1)-ph(il,2)))                             !precip
+        ft(il, 1) = -lvcp(il, 1) * sigd(il) * evap(il, 1) - &
+                lfcp(il, 1) * sigd(il) * evap(il, 1) * faci(il, 1) - &
+                lfcp(il, 1) * sigd(il) * (fondue(il, 1) * wt(il, 1)) / &
+                        (100. * (ph(il, 1) - ph(il, 2)))                             !precip
       ELSE
-        ft(il, 1) = -lvcp(il, 1)*sigd(il)*evap(il, 1)
+        ft(il, 1) = -lvcp(il, 1) * sigd(il) * evap(il, 1)
       END IF
 
-      ft(il, 1) = ft(il, 1) - 0.009*grav*sigd(il)*mp(il, 2)*t_wake(il, 1)*b(il, 1)*work(il)
+      ft(il, 1) = ft(il, 1) - 0.009 * grav * sigd(il) * mp(il, 2) * t_wake(il, 1) * b(il, 1) * work(il)
 
       IF (cvflag_ice) THEN
-        ft(il, 1) = ft(il, 1) + 0.01*sigd(il)*wt(il, 1)*(cl-cpd)*water(il, 2) * &
-                                     (t_wake(il,2)-t_wake(il,1))*work(il)/cpn(il, 1) + &
-                                0.01*sigd(il)*wt(il, 1)*(ci-cpd)*ice(il, 2) * &
-                                     (t_wake(il,2)-t_wake(il,1))*work(il)/cpn(il, 1)
+        ft(il, 1) = ft(il, 1) + 0.01 * sigd(il) * wt(il, 1) * (cl - cpd) * water(il, 2) * &
+                (t_wake(il, 2) - t_wake(il, 1)) * work(il) / cpn(il, 1) + &
+                0.01 * sigd(il) * wt(il, 1) * (ci - cpd) * ice(il, 2) * &
+                        (t_wake(il, 2) - t_wake(il, 1)) * work(il) / cpn(il, 1)
       ELSE
-        ft(il, 1) = ft(il, 1) + 0.01*sigd(il)*wt(il, 1)*(cl-cpd)*water(il, 2) * &
-                                     (t_wake(il,2)-t_wake(il,1))*work(il)/cpn(il, 1)
+        ft(il, 1) = ft(il, 1) + 0.01 * sigd(il) * wt(il, 1) * (cl - cpd) * water(il, 2) * &
+                (t_wake(il, 2) - t_wake(il, 1)) * work(il) / cpn(il, 1)
       END IF
 
       ftd(il, 1) = ft(il, 1)                                                  ! fin precip
 
-      IF ((0.01*grav*work(il)*am(il))>=delti) iflag(il) = 1 !consist vect
-!jyg<
-        IF (fl_cor_ebil >= 2) THEN
-          ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*am(il) * &
-                    ((t(il,2)-t(il,1))*cpn(il,2)+gz(il,2)-gz(il,1))/cpn(il,1)
-        ELSE
-          ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*am(il) * &
-                    (t(il,2)-t(il,1)+(gz(il,2)-gz(il,1))/cpn(il,1))
-        ENDIF
-!>jyg
+      IF ((0.01 * grav * work(il) * am(il))>=delti) iflag(il) = 1 !consist vect
+      !jyg<
+      IF (fl_cor_ebil >= 2) THEN
+        ft(il, 1) = ft(il, 1) + 0.01 * grav * work(il) * am(il) * &
+                ((t(il, 2) - t(il, 1)) * cpn(il, 2) + gz(il, 2) - gz(il, 1)) / cpn(il, 1)
+      ELSE
+        ft(il, 1) = ft(il, 1) + 0.01 * grav * work(il) * am(il) * &
+                (t(il, 2) - t(il, 1) + (gz(il, 2) - gz(il, 1)) / cpn(il, 1))
+      ENDIF
+      !>jyg
     END IF ! iflag
   END DO
-
 
   DO j = 2, nl
     IF (iflag_mix>0) THEN
       DO il = 1, ncum
-! FH WARNING a modifier :
+        ! FH WARNING a modifier :
         cpinv = 0.
-! cpinv=1.0/cpn(il,1)
+        ! cpinv=1.0/cpn(il,1)
         IF (j<=inb(il) .AND. iflag(il)<=1) THEN
-          ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*ment(il, j, 1) * &
-                     (hent(il,j,1)-h(il,1)+t(il,1)*(cpv-cpd)*(rr(il,1)-qent(il,j,1)))*cpinv
+          ft(il, 1) = ft(il, 1) + 0.01 * grav * work(il) * ment(il, j, 1) * &
+                  (hent(il, j, 1) - h(il, 1) + t(il, 1) * (cpv - cpd) * (rr(il, 1) - qent(il, j, 1))) * cpinv
         END IF ! j
       END DO
     END IF
   END DO
-! fin sature
-
+  ! fin sature
 
   DO il = 1, ncum
     IF (iflag(il)<=1) THEN
-!JYG1  Correction pour mieux conserver l'eau (conformite avec CONVECT4.3)
-      fr(il, 1) = 0.01*grav*mp(il, 2)*(rp(il,2)-rr_wake(il,1))*work(il) + &
-                  sigd(il)*evap(il, 1)
-!!!                  sigd(il)*0.5*(evap(il,1)+evap(il,2))
+      !JYG1  Correction pour mieux conserver l'eau (conformite avec CONVECT4.3)
+      fr(il, 1) = 0.01 * grav * mp(il, 2) * (rp(il, 2) - rr_wake(il, 1)) * work(il) + &
+              sigd(il) * evap(il, 1)
+      !!!                  sigd(il)*0.5*(evap(il,1)+evap(il,2))
 
       fqd(il, 1) = fr(il, 1) !precip
 
-      fr(il, 1) = fr(il, 1) + 0.01*grav*am(il)*(rr(il,2)-rr(il,1))*work(il)        !sature
-
-      fu(il, 1) = fu(il, 1) + 0.01*grav*work(il)*(mp(il,2)*(up(il,2)-u(il,1)) + &
-                                                  am(il)*(u(il,2)-u(il,1)))
-      fv(il, 1) = fv(il, 1) + 0.01*grav*work(il)*(mp(il,2)*(vp(il,2)-v(il,1)) + &
-                                                  am(il)*(v(il,2)-v(il,1)))
+      fr(il, 1) = fr(il, 1) + 0.01 * grav * am(il) * (rr(il, 2) - rr(il, 1)) * work(il)        !sature
+
+      fu(il, 1) = fu(il, 1) + 0.01 * grav * work(il) * (mp(il, 2) * (up(il, 2) - u(il, 1)) + &
+              am(il) * (u(il, 2) - u(il, 1)))
+      fv(il, 1) = fv(il, 1) + 0.01 * grav * work(il) * (mp(il, 2) * (vp(il, 2) - v(il, 1)) + &
+              am(il) * (v(il, 2) - v(il, 1)))
     END IF ! iflag
   END DO ! il
 
 
-!AC!     do j=1,ntra
-!AC!      do il=1,ncum
-!AC!       if (iflag(il) .le. 1) THEN
-!AC!       if (cvflag_grav) THEN
-!AC!        ftra(il,1,j)=ftra(il,1,j)+0.01*grav*work(il)
-!AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
-!AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
-!AC!       else
-!AC!        ftra(il,1,j)=ftra(il,1,j)+0.1*work(il)
-!AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
-!AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
-!AC!       endif
-!AC!       endif  ! iflag
-!AC!      enddo
-!AC!     enddo
+  !AC!     do j=1,ntra
+  !AC!      do il=1,ncum
+  !AC!       if (iflag(il) .le. 1) THEN
+  !AC!       if (cvflag_grav) THEN
+  !AC!        ftra(il,1,j)=ftra(il,1,j)+0.01*grav*work(il)
+  !AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
+  !AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
+  !AC!       else
+  !AC!        ftra(il,1,j)=ftra(il,1,j)+0.1*work(il)
+  !AC!    :                     *(mp(il,2)*(trap(il,2,j)-tra(il,1,j))
+  !AC!    :             +am(il)*(tra(il,2,j)-tra(il,1,j)))
+  !AC!       endif
+  !AC!       endif  ! iflag
+  !AC!      enddo
+  !AC!     enddo
 
   DO j = 2, nl
     DO il = 1, ncum
       IF (j<=inb(il) .AND. iflag(il)<=1) THEN
-        fr(il, 1) = fr(il, 1) + 0.01*grav*work(il)*ment(il, j, 1)*(qent(il,j,1)-rr(il,1))
-        fr_comp(il,1) = fr_comp(il,1) + 0.01*grav*work(il)*ment(il, j, 1)*(qent(il,j,1)-rr(il,1))
-        fu(il, 1) = fu(il, 1) + 0.01*grav*work(il)*ment(il, j, 1)*(uent(il,j,1)-u(il,1))
-        fv(il, 1) = fv(il, 1) + 0.01*grav*work(il)*ment(il, j, 1)*(vent(il,j,1)-v(il,1))
+        fr(il, 1) = fr(il, 1) + 0.01 * grav * work(il) * ment(il, j, 1) * (qent(il, j, 1) - rr(il, 1))
+        fr_comp(il, 1) = fr_comp(il, 1) + 0.01 * grav * work(il) * ment(il, j, 1) * (qent(il, j, 1) - rr(il, 1))
+        fu(il, 1) = fu(il, 1) + 0.01 * grav * work(il) * ment(il, j, 1) * (uent(il, j, 1) - u(il, 1))
+        fv(il, 1) = fv(il, 1) + 0.01 * grav * work(il) * ment(il, j, 1) * (vent(il, j, 1) - v(il, 1))
       END IF ! j
     END DO
   END DO
 
-!AC!      do k=1,ntra
-!AC!       do j=2,nl
-!AC!        do il=1,ncum
-!AC!         if (j.le.inb(il) .AND. iflag(il) .le. 1) THEN
-!AC!
-!AC!          if (cvflag_grav) THEN
-!AC!           ftra(il,1,k)=ftra(il,1,k)+0.01*grav*work(il)*ment(il,j,1)
-!AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
-!AC!          else
-!AC!           ftra(il,1,k)=ftra(il,1,k)+0.1*work(il)*ment(il,j,1)
-!AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
-!AC!          endif
-!AC!
-!AC!         endif
-!AC!        enddo
-!AC!       enddo
-!AC!      enddo
-! PRINT*,'cv3_yield apres ft'
-
-!jyg<
-!-----------------------------------------------------------
-           IF (ok_optim_yield) THEN                       !|
-!-----------------------------------------------------------
-
-!***                                                      ***
-!***    Compute convective mass fluxes upwd and dnwd      ***
-
-! =================================================
-!              upward fluxes                      |
-! ------------------------------------------------
-
-upwd(:,:) = 0.
-up_to(:,:) = 0.
-up_from(:,:) = 0.
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-  IF (adiab_ascent_mass_flux_depends_on_ejectliq) THEN
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!! The decrease of the adiabatic ascent mass flux due to ejection of precipitation 
-!! is taken into account. 
-!! WARNING : in the present version, taking into account the mass-flux decrease due to 
-!! precipitation ejection leads to water conservation violation.
-
-! - Upward mass flux of mixed draughts
-!---------------------------------------
-DO i = 2, nl
-  DO j = 1, i-1
-    DO il = 1, ncum
-      IF (i<=inb(il)) THEN
-        up_to(il,i) = up_to(il,i) + ment(il,j,i)
-      ENDIF
+  !AC!      do k=1,ntra
+  !AC!       do j=2,nl
+  !AC!        do il=1,ncum
+  !AC!         if (j.le.inb(il) .AND. iflag(il) .le. 1) THEN
+  !AC!
+  !AC!          if (cvflag_grav) THEN
+  !AC!           ftra(il,1,k)=ftra(il,1,k)+0.01*grav*work(il)*ment(il,j,1)
+  !AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
+  !AC!          else
+  !AC!           ftra(il,1,k)=ftra(il,1,k)+0.1*work(il)*ment(il,j,1)
+  !AC!     :                *(traent(il,j,1,k)-tra(il,1,k))
+  !AC!          endif
+  !AC!
+  !AC!         endif
+  !AC!        enddo
+  !AC!       enddo
+  !AC!      enddo
+  ! PRINT*,'cv3_yield apres ft'
+
+  !jyg<
+  !-----------------------------------------------------------
+  IF (ok_optim_yield) THEN                       !|
+    !-----------------------------------------------------------
+
+    !***                                                      ***
+    !***    Compute convective mass fluxes upwd and dnwd      ***
+
+    ! =================================================
+    !              upward fluxes                      |
+    ! ------------------------------------------------
+
+    upwd(:, :) = 0.
+    up_to(:, :) = 0.
+    up_from(:, :) = 0.
+
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    IF (adiab_ascent_mass_flux_depends_on_ejectliq) THEN
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !! The decrease of the adiabatic ascent mass flux due to ejection of precipitation
+      !! is taken into account.
+      !! WARNING : in the present version, taking into account the mass-flux decrease due to
+      !! precipitation ejection leads to water conservation violation.
+
+      ! - Upward mass flux of mixed draughts
+      !---------------------------------------
+      DO i = 2, nl
+        DO j = 1, i - 1
+          DO il = 1, ncum
+            IF (i<=inb(il)) THEN
+              up_to(il, i) = up_to(il, i) + ment(il, j, i)
+            ENDIF
+          ENDDO
+        ENDDO
+      ENDDO
+
+      DO j = 3, nl
+        DO i = 2, j - 1
+          DO il = 1, ncum
+            IF (j<=inb(il)) THEN
+              up_from(il, i) = up_from(il, i) + ment(il, i, j)
+            ENDIF
+          ENDDO
+        ENDDO
+      ENDDO
+
+      ! The difference between upwd(il,i) and upwd(il,i-1) is due to updrafts ending in layer
+      !(i-1) (theses drafts cross interface (i-1) but not interface(i)) and to updrafts starting
+      !from layer (i-1) (theses drafts cross interface (i) but not interface(i-1)):
+
+      DO i = 2, nlp
+        DO il = 1, ncum
+          IF (i<=inb(il) + 1) THEN
+            upwd(il, i) = max(0., upwd(il, i - 1) - up_to(il, i - 1) + up_from(il, i - 1))
+          ENDIF
+        ENDDO
+      ENDDO
+
+      ! - Total upward mass flux
+      !---------------------------
+      DO i = 2, nlp
+        DO il = 1, ncum
+          IF (i<=inb(il) + 1) THEN
+            upwd(il, i) = upwd(il, i) + ma(il, i)
+          ENDIF
+        ENDDO
+      ENDDO
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !! The decrease of the adiabatic ascent mass flux due to ejection of precipitation
+      !! is not taken into account.
+
+      ! - Upward mass flux
+      !-------------------
+      DO i = 2, nl
+        DO il = 1, ncum
+          IF (i<=inb(il)) THEN
+            up_to(il, i) = m(il, i)
+          ENDIF
+        ENDDO
+        DO j = 1, i - 1
+          DO il = 1, ncum
+            IF (i<=inb(il)) THEN
+              up_to(il, i) = up_to(il, i) + ment(il, j, i)
+            ENDIF
+          ENDDO
+        ENDDO
+      ENDDO
+
+      DO i = 1, nl
+        DO il = 1, ncum
+          IF (i<=inb(il)) THEN
+            up_from(il, i) = cbmf(il) * wghti(il, i)
+          ENDIF
+        ENDDO
+      ENDDO
+
+      DO j = 3, nl
+        DO i = 2, j - 1
+          DO il = 1, ncum
+            IF (j<=inb(il)) THEN
+              up_from(il, i) = up_from(il, i) + ment(il, i, j)
+            ENDIF
+          ENDDO
+        ENDDO
+      ENDDO
+
+      ! The difference between upwd(il,i) and upwd(il,i-1) is due to updrafts ending in layer
+      !(i-1) (theses drafts cross interface (i-1) but not interface(i)) and to updrafts starting
+      !from layer (i-1) (theses drafts cross interface (i) but not interface(i-1)):
+
+      DO i = 2, nlp
+        DO il = 1, ncum
+          IF (i<=inb(il) + 1) THEN
+            upwd(il, i) = max(0., upwd(il, i - 1) - up_to(il, i - 1) + up_from(il, i - 1))
+          ENDIF
+        ENDDO
+      ENDDO
+
+    ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
+    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+    ! =================================================
+    !              downward fluxes                    |
+    ! ------------------------------------------------
+    dnwd(:, :) = 0.
+    dn_to(:, :) = 0.
+    dn_from(:, :) = 0.
+    DO i = 1, nl
+      DO j = i + 1, nl
+        DO il = 1, ncum
+          IF (j<=inb(il)) THEN
+            !!        dn_to(il,i) = dn_to(il,i) + ment(il,j,i)       !jyg,20220202
+            dn_to(il, i) = dn_to(il, i) - ment(il, j, i)
+          ENDIF
+        ENDDO
+      ENDDO
     ENDDO
-  ENDDO
-ENDDO
-
-DO j = 3, nl
-  DO i = 2, j-1
-    DO il = 1, ncum
-      IF (j<=inb(il)) THEN
-        up_from(il,i) = up_from(il,i) + ment(il,i,j)
-      ENDIF
+
+    DO j = 1, nl
+      DO i = j + 1, nl
+        DO il = 1, ncum
+          IF (i<=inb(il)) THEN
+            !!        dn_from(il,i) = dn_from(il,i) + ment(il,i,j)   !jyg,20220202
+            dn_from(il, i) = dn_from(il, i) - ment(il, i, j)
+          ENDIF
+        ENDDO
+      ENDDO
     ENDDO
-  ENDDO
-ENDDO
-
-! The difference between upwd(il,i) and upwd(il,i-1) is due to updrafts ending in layer 
-!(i-1) (theses drafts cross interface (i-1) but not interface(i)) and to updrafts starting 
-!from layer (i-1) (theses drafts cross interface (i) but not interface(i-1)): 
-
-DO i = 2, nlp
-  DO il = 1, ncum
-    IF (i<=inb(il)+1) THEN
-      upwd(il,i) = max(0., upwd(il,i-1) - up_to(il,i-1) + up_from(il,i-1))
-    ENDIF
-  ENDDO
-ENDDO
-
-! - Total upward mass flux
-!---------------------------
-DO i = 2, nlp
-  DO il = 1, ncum
-    IF (i<=inb(il)+1) THEN
-      upwd(il,i) = upwd(il,i) + ma(il,i)
-    ENDIF
-  ENDDO
-ENDDO
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-  ELSE ! (adiab_ascent_mass_flux_depends_on_ejectliq)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!! The decrease of the adiabatic ascent mass flux due to ejection of precipitation 
-!! is not taken into account. 
-
-! - Upward mass flux
-!-------------------
-DO i = 2, nl
-  DO il = 1, ncum
-    IF (i<=inb(il)) THEN
-      up_to(il,i) = m(il,i)
-    ENDIF
-  ENDDO
-  DO j = 1, i-1
-    DO il = 1, ncum
-      IF (i<=inb(il)) THEN
-        up_to(il,i) = up_to(il,i) + ment(il,j,i)
-      ENDIF
+
+    ! The difference between dnwd(il,i) and dnwd(il,i+1) is due to downdrafts ending in layer
+    !(i) (theses drafts cross interface (i+1) but not interface(i)) and to downdrafts
+    !starting from layer (i) (theses drafts cross interface (i) but not interface(i+1)):
+
+    DO i = nl - 1, 1, -1
+      DO il = 1, ncum
+        !!    dnwd(il,i) = max(0., dnwd(il,i+1) - dn_to(il,i) + dn_from(il,i)) !jyg,20220202
+        dnwd(il, i) = min(0., dnwd(il, i + 1) - dn_to(il, i) + dn_from(il, i))
+      ENDDO
     ENDDO
-  ENDDO
-ENDDO
-
-DO i = 1, nl
-  DO il = 1, ncum
-    IF (i<=inb(il)) THEN
-      up_from(il,i) = cbmf(il)*wghti(il,i)
-    ENDIF
-  ENDDO
-ENDDO
-
-DO j = 3, nl
-  DO i = 2, j-1
-    DO il = 1, ncum
-      IF (j<=inb(il)) THEN
-        up_from(il,i) = up_from(il,i) + ment(il,i,j)
-      ENDIF
-    ENDDO
-  ENDDO
-ENDDO
-
-! The difference between upwd(il,i) and upwd(il,i-1) is due to updrafts ending in layer 
-!(i-1) (theses drafts cross interface (i-1) but not interface(i)) and to updrafts starting 
-!from layer (i-1) (theses drafts cross interface (i) but not interface(i-1)): 
-
-DO i = 2, nlp
-  DO il = 1, ncum
-    IF (i<=inb(il)+1) THEN
-      upwd(il,i) = max(0., upwd(il,i-1) - up_to(il,i-1) + up_from(il,i-1))
-    ENDIF
-  ENDDO
-ENDDO
-
-
-  ENDIF ! (adiab_ascent_mass_flux_depends_on_ejectliq) ELSE
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-! =================================================
-!              downward fluxes                    |
-! ------------------------------------------------
-dnwd(:,:) = 0.
-dn_to(:,:) = 0.
-dn_from(:,:) = 0.
-DO i = 1, nl
-  DO j = i+1, nl
-    DO il = 1, ncum
-      IF (j<=inb(il)) THEN
-!!        dn_to(il,i) = dn_to(il,i) + ment(il,j,i)       !jyg,20220202
-        dn_to(il,i) = dn_to(il,i) - ment(il,j,i)
-      ENDIF
-    ENDDO
-  ENDDO
-ENDDO
-
-DO j = 1, nl
-  DO i = j+1, nl
-    DO il = 1, ncum
-      IF (i<=inb(il)) THEN
-!!        dn_from(il,i) = dn_from(il,i) + ment(il,i,j)   !jyg,20220202
-        dn_from(il,i) = dn_from(il,i) - ment(il,i,j)
-      ENDIF
-    ENDDO
-  ENDDO
-ENDDO
-
-! The difference between dnwd(il,i) and dnwd(il,i+1) is due to downdrafts ending in layer 
-!(i) (theses drafts cross interface (i+1) but not interface(i)) and to downdrafts 
-!starting from layer (i) (theses drafts cross interface (i) but not interface(i+1)): 
-
-DO i = nl-1, 1, -1
-  DO il = 1, ncum
-!!    dnwd(il,i) = max(0., dnwd(il,i+1) - dn_to(il,i) + dn_from(il,i)) !jyg,20220202
-    dnwd(il,i) = min(0., dnwd(il,i+1) - dn_to(il,i) + dn_from(il,i))
-  ENDDO
-ENDDO
-! =================================================
-
-!-----------------------------------------------------------
-        ENDIF !(ok_optim_yield)                           !|
-!-----------------------------------------------------------
-!>jyg
-
-! ***  calculate tendencies of potential temperature and mixing ratio  ***
-! ***               at levels above the lowest level                   ***
-
-! ***  first find the net saturated updraft and downdraft mass fluxes  ***
-! ***                      through each level                          ***
-
-
-!jyg<
-!!  DO i = 2, nl + 1 ! newvecto: mettre nl au lieu nl+1?
+    ! =================================================
+
+    !-----------------------------------------------------------
+  ENDIF !(ok_optim_yield)                           !|
+  !-----------------------------------------------------------
+  !>jyg
+
+  ! ***  calculate tendencies of potential temperature and mixing ratio  ***
+  ! ***               at levels above the lowest level                   ***
+
+  ! ***  first find the net saturated updraft and downdraft mass fluxes  ***
+  ! ***                      through each level                          ***
+
+
+  !jyg<
+  !!  DO i = 2, nl + 1 ! newvecto: mettre nl au lieu nl+1?
   DO i = 2, nl
-!>jyg 
+    !>jyg
 
     num1 = 0
